
class Rational
  def to_tex(plus="", paren=false)
    if paren && numerator<0
      paren = ["\\left(", "\\right)"]
    else
      paren = ["",""]
    end
    s=(numerator<0) ? "-" : plus
    if (denominator==1)
      return paren[0]+s+numerator.abs.to_s+paren[1]
    end
    return paren[0]+s+"\\frac{#{numerator.abs}}{#{denominator}}"+paren[1]
  end
end


def makeex
  while true
    d = Rational((rand(6)+1)*(rand(2)*2-1), rand(4)+2)
    if d.denominator>1
      a1 = Rational((d.denominator*(rand(4)+2)+rand(d.denominator-1))*(rand(2)*2-1), d.denominator)
      n = rand(5)+3
      m = n+2+rand(4)
      an = a1+(n-1)*d
      am = a1+(m-1)*d
      ex = "Von einer AF sind $a_{#{n}}=#{an.to_tex}$ und $a_{#{m}}=#{am.to_tex}$ bekannt. Berechnen Sie das erste Glied $a_1$ und die Differenz $d$."
      sol = "$d=\\frac{a_{#{m}}-a_{#{n}}}{#{m-n}} = \\frac{#{(am-an).to_tex}}{#{m-n}} = #{d.to_tex}$. Daraus folgt z.B. $a_1 = a_{#{n}} - (#{n}-1)\\cdot #{d.to_tex("",true)} = #{an.to_tex} - #{n-1} \\cdot #{d.to_tex("",true)} = #{a1.to_tex}$"
      return [ex,sol]
    end
  end

end

p Array.new(10) { makeex }
