require "./header-footer.rb"
#
# (a*x+b)*(c*x+d)+(e*x+f)*(g*x+h)
# = 
# (e*g+a*c)*x^2 + (e*h+f*g+a*d+b*c)*x + (f*h+b*d)
#
# 
#


class Rational
  def to_tex(op=false, coeff=false)
    sign = self<0 ? "-" : (op ? "+" : "")
    if denominator==1
      if numerator.abs==1 && coeff
        return "#{sign}"
      end
      return "#{sign}#{numerator.abs}"
    end
    return "#{sign}\\frac{#{numerator.abs}}{#{denominator}}"      
  end
end


def randRat()
  while true
    r = Rational((rand(9)+2)*(rand(2)*2-1), (rand(9)+2))
    return r if r.denominator>1
  end
end

def isquare?(i)
  return (Math::sqrt(i).to_i)**2==i
end

def square?(r)
  return false if r<0
  return isquare?(r.denominator) && isquare?(r.numerator)
end

def sqrt(r)
  return Rational(Math.sqrt(r.numerator).to_i, Math.sqrt(r.denominator).to_i)
end

def decent(r)
  return r.numerator.abs<101 && r.numerator.abs>0 && r.denominator.abs<101 && r.denominator>1
end

def ex()
  # (x+q)^2
  while true
    q = Rational((rand(7)+2)*(rand(2)*2-1),1)
    
    a = randRat()
    ac = randRat()
    c = ac/a
    eg = 1-ac
    e = randRat()
    g = eg/e
    next if !decent(c) || !decent(g)

    # if b,d were known:    
    #    f=((-sqrt((4-4*e*g)*q^2+((-4*a*d)-4*b*c)*q+b*d*(4*e*g+2*a*c)+a^2*d^2+b^2*c^2))+2*q-a*d-b*c)/(2*g)
    ok = false
    b,d,radikand = nil
    1000.times{|nt|
      b = randRat()
      d = randRat()
      radikand = (4-4*e*g)*q*q+((-4*a*d)-4*b*c)*q+b*d*(4*e*g+2*a*c)+a*a*d*d+b*b*c*c
      if square?(radikand) && radikand.numerator<=10000 && radikand.denominator<=10000
        # p nt
        ok = true
        break
      end
    }
    if !ok
      # puts "oops"
      next
    end
    # p radikand
    f=((-sqrt(radikand))+2*q-a*d-b*c)/(2*g)
    # p f
    if decent(f)
      h = (q*q-b*d)/f
      # p h
      if decent(h) && decent(e*h) && decent(f*g) && decent(f*h) && decent(b*c) && decent(b*d)
        res = [a,b,c,d,e,f,g,h,q]
        # p res

        ex = "\\left(#{a.to_tex(false,true)}x#{b.to_tex(true,false)}\\right)\\cdot\\left(#{c.to_tex(false,true)}x#{d.to_tex(true,false)}\\right)+"
        ex += "\\left(#{e.to_tex(false,true)}x#{f.to_tex(true,false)}\\right)\\cdot\\left(#{g.to_tex(false,true)}x#{h.to_tex(true,false)}\\right)"
        # p ex

        # (a*x+b)*(c*x+d)+(e*x+f)*(g*x+h)

        sol = "#{ac.to_tex(false,true)}x^2#{(a*d).to_tex(true,true)}x#{(b*c).to_tex(true,true)}x#{(b*d).to_tex(true,false)}"
        sol += "#{eg.to_tex(true,true)}x^2#{(e*h).to_tex(true,true)}x#{(f*g).to_tex(true,true)}x#{(f*h).to_tex(true,false)}="
        # (e*g+a*c)*x^2 + (e*h+f*g+a*d+b*c)*x + (f*h+b*d)
        sol += "x^2#{(2*q).to_tex(true,true)}x#{(q*q).to_tex(true,false)} = \\left(x#{q.to_tex(true,false)}\\right)^2"

        # p sol
        return ["$#{ex}$","$#{sol}$"]
      end
    end
  end
  
end

name = "ausmulundbinom"


ex = Array.new(10){ex()}
res = "Ausmultiplizieren, zusammenfassen und zuletzt faktorisieren."

res += header(name)
res += ex.inspect
res += footer(name, " <br><hr> ", " <br><hr> ", 3)
xclip(res)
