require './header-footer.rb'

class Rational
  def to_tex(amplify=1)
    if denominator==1
      return to_s
    else
      s = numerator<0 ? "-" : ""
      return "#{s}\\frac{#{numerator.abs*amplify}}{#{denominator*amplify}}"
    end
  end  
end

def tex2rat(s)
  s=s.gsub("\\cdot","*").gsub(":","/").gsub("\\left", "").gsub("\\right","").gsub("$","")
  s=s.gsub(/\\frac\{(.*?)\}\{(.*?)\}/,"Rational(\\1,\\2)").gsub("=",",")
  s
end

def gcd(a,b)
  return a if b==0
  return gcd(b, a%b)
end

def lcm(a,b)
  return a*b/gcd(a,b)
end

def gcds(a)
  if (a.size==2)
    return gcd(a[0],a[1])
  else
    return gcd(a[-1], gcds(a[0..-2]))
  end
end


def randrat(max=9)
  r=nil
  begin
    r = Rational(rand(max)+1, rand(max-1)+2)
  end until r.denominator!=1
  return r
end


class RatExp
  attr_accessor :r, :op, :amp, :neg

  def initialize(r, op=nil)
    @r = r
    if @r.is_a(Numeric)
      @r = @r.rationalize()
      @neg= (@r<0)
    end
    @op=op
    @amp = 1
  end

  def +(other)   
    return RatExp.new([self, other], :+)
  end
  
  def -(other)   
    return RatExp.new([self, other], :-)
  end
  
  def *(other)   
    return RatExp.new([self, other], :*)
  end

  def /(other)   
    return RatExp.new([self, other], :/)
  end

  
    
  def ex
    if @r.is_a?(Rational)
      return @r.to_tex(@amp)
    end
    left = @r[0].ex
    right = @r[1].ex
    if (@op==:- && (@r[1].neg || @r[1].op==:+ || @r[1].op==:-)) ||
       ((@op==:* || @op==:/) && (@r[1].op==:+ || @r[1].op==:-)) ||
       (@op==:/ && @r[1].op)
      right = "\\left("+right+"\\right)"
    end
    if (
    end
    if @op==:* || @op==:-
   end

  def sol

  end
