# coding: utf-8
require "./header-footer.rb"

class Rational
  def to_tex(op=false, amplify=1)
    if denominator==1
      return (op && self>=0 ? "+" : "")+to_i.to_s
    else
      s = numerator<0 ? "-" : (op ? "+" : "")
      return "#{s}\\frac{#{numerator.abs*amplify}}{#{denominator*amplify}}"
    end
  end  
end

def randRat(nmin, nmax, dmin, dmax)
  r = nil
  50.times{
    r = Rational(rand(nmax+1)+nmin, rand(dmax+1)+dmin)
    if r.denominator>=dmin
      r*=(rand(2)*2-1)
      return r
    end
  }
  return r
end


def af()
  a1 = randRat(2,5,3,6)
  d = randRat(2,5,3,6)
  ex = "$"+Array.new(5){|n| (a1+n*d).to_tex()}.join(",\\,")+"\\ldots$"
  sol = "Konstante Differenz von $#{d.to_tex()}$, und damit ist $x_{n}=#{a1.to_tex()}#{d.to_tex(true)}\\cdot(n-1)$."
  return [ex,sol]
end

def gf()
  g1 = randRat(2,5,3,6)
  q = randRat(2,5,2,5)
  g1/=q*q
  ex = "$"+Array.new(5){|n| (g1*q**n).to_tex()}.join(",\\,")+"\\ldots$"
  sol = "Konstanter Quotient von $#{q.to_tex()}$, und damit ist $x_{n}=#{g1.to_tex()}\\cdot\\left(#{q.to_tex()}\\right)^{(n-1)}$."
  return [ex,sol]
end

def ex()
  return rand(2)==0 ? af() : gf()
end


  
type = ARGV[0]
res = "" 
if (type.to_i==1)
  name = "folgenafgf"

  all = Array.new(10){ex()}
  
  res = "Bestimmen Sie eine Formel, die aus der Nummer $n$ des Elements den Wert berechnet:\n"
  res += header(name)
  res += all.inspect
  res += footer(name, " <hr> ", " <hr> ")+"\n"

end

xclip(res)
