require "../header-footer.rb"


exos = [
    [
     ["(x+1)**2-2",[-3,3,-3,3], "quadratisch, $f(x)=(x+1)^2-2$"],
     ["2^x",[-4,2,-1,5], "exponentiell, $f(x)=2^x$"],
     ["log(x)/log(2)", [0.01,6,-3,3], "logarithmisch, $f(x)=\\log_2(x)$"],
    ],[
      ["sin(x*3.1415926)",[-3,3,-3,3],"Sinusfunktion, $f(x)=\\sin(x \\cdot \\pi)=\\sin(x \\cdot 180^\\circ)$"],
      ["0.5*x+1",[-3,3,-2,4], "linear, $f(x)=\\frac{1}{2}x+1$"],
      ["sqrt(x)",[0,6,-1,5],"Wurzelfunktion, $f(x)=\\sqrt{x}$"],
    ],[  
      ["0.5^x",[-2,4,-1,5],"exponentiell, $f(x)=\\left(\\frac{1}{2}\\right)^x$"],
      ["-x-1",[-3,3,-4,2],"linear, $f(x)=-x-1$"],
      ["-sqrt(x)",[0,6,-5,1],"Wurzelfunktion, $f(x)=-\\sqrt{x}$"],
    ],[  
      ["log(x)",[0.01,6,-3,3],"logarithmisch, $f(x)=\\ln(x)$"],
      ["-(x-1)^2+1",[-2,4,-4,2],"quadratisch, $f(x)=-(x-1)^2+1$"],
      ["cos(x*3.1415926)",[-3,3,-3,3],"Sinusfunktion, $f(x)=\\cos(x\\cdot \\pi)=\\cos(x \\cdot 180^\\circ)$"],
    ],[  
      ["x^2",[-3,3,-1,5],"quadratisch, $f(x)=x^2$"],
      ["-log(x)/log(2)",[0.01,6,-3,3],"logarithmisch, $f(x)=-\\log_2(x)$"],
      ["-2^x",[-4,2,-5,1],"exponentiell, $f(x)=-2^x$"],
       ]
]   

url = "https://fginfo.ksbg.ch/~ivo/miniaufgaben/"
scp = "ivo@fginfo:public_html/miniaufgaben/."
name = "funktionstypenerkennen"


def cmd(c)
    puts c
    puts `#{c}`
end

exandsol = []

exos.each.with_index{|e,i|
  break if e[0][0]==""
  sol = ""
  ex = "include header;

rfunc[] f={
"
    dom = "real[][] domain={";
    e.each{|f|
        ex += "  new real(real x) { return #{f[0]}; },"
        dom += "{#{f[1].join(',')}},"
        sol += f[2]+"$\\qquad$"
    }
    ex += "};\n\n#{dom}};\n"

    ex += "include footer;\n"
  file = "exo.asy"
  File.write(file,ex)
  cmd("asy #{file}")
  png = name+i.to_s+".png"
  cmd("inkscape -e #{png} -d 200 -b white exo.eps")
  `scp #{png} #{scp}`
  exandsol.push(["<img src='#{url}#{png}?x=#{rand(1000000)}'>", sol])
}
        
fulltext = "Bestimmen Sie die Funktionstypen als einen Typ aus
  * linear, quadratisch, exponentiell, logarithmisch, Wurzelfunktion, Sinusfunktion
Das Angeben der Funktionsgleichung gibt Bonuspunkte. Mit zwei korrekten Funktionstermen kann ein dritter falscher Typ kompensiert werden.
"+header(name)+exandsol.inspect+footer(name, "<hr>","<br>")

xclip(fulltext)
