

def vecs_with_square_length(l)
  res = []
  max = Math.sqrt(l).to_i
  for x in 0..max
    for y in x..max
      z = l-x*x-y*y
      if (z>=y*y)
        z = Math.sqrt(z).to_i
        if x*x+y*y+z*z==l
          res.push([x,y,z])
        end
      end
    end
  end
  return res
end

def perms(vec)
  vec.permutation.each{|p|
    8.times{|s|
      signs = Array.new(3){|i| (s >> i & 1 == 1) ? 1 : -1}
      yield Array.new(3){|i| p[i]*signs[i]}
    }
  }
end

def scalar(a,b)
  return a[0]*b[0]+a[1]*b[1]+a[2]*b[2]
end

def ordered?(a,b)
  3.times{|i|
    return false if a[i]<b[i]
    return true if a[i]>b[i]
  }
  return false
end

def cross(a,b)
  return [a[1]*b[2]-a[2]*b[1], a[2]*b[0]-a[0]*b[2], a[0]*b[1]-a[1]*b[0]]
end

def addifnew(res,vecs)
  if res.all?{|v| v[0]!=vecs[0]}
    if vecs.all?{|v| v.any?{|x| x>0}}
      if scalar(cross(vecs[0],vecs[1]),vecs[2])>0
        res.push(vecs)
      end
    end
  end
end


def getOrthogonals(vecs)
  res = []
  for i in 0...(vecs.size)
    for j in i...(vecs.size)
      for k in j...(vecs.size)
        perms(vecs[i]){|vi|
          perms(vecs[j]){|vj|
            if (ordered?(vi,vj) && scalar(vi,vj)==0)
              perms(vecs[k]){|vk|
                if (scalar(vi,vk)==0 && scalar(vj,vk)==0 && ordered?(vj,vk))
                  addifnew(res,[vi,vj,vk])
                end
              }
            end
          }
        }
      end
    end
  end
  return res
end


def get30degrees(vecs)
  res = []
  for i in 0...(vecs.size)
    for j in i...(vecs.size)
      perms(vecs[i]){|vi|
        perms(vecs[j]){|vj|
          if scalar(vi,vj)*scalar(vi,vj)*4==scalar(vi,vi)*scalar(vj,vj)
            p [vi,vj]
            res.push([vi,vj])
          end
        }
      }
    end
  end
  return res
end



def tripel(max)
    res = []
    for x in 1..max
        for y in x..max
            for z in y..max
                l2 = x*x+y*y+z*z
                if l2 == (Math.sqrt(l2).to_i)**2
                    res.push(Vector.elements([Rational(x,1),Rational(y,1),Rational(z,1)]))
                end
            end
        end
    end
    return res
end

if false

  bases = Hash.new
  [9,49,81,121,169,17*17,19*19,23*23,29*29].each{|i|
    r = vecs_with_square_length(i)
    if (r.size>0)
      o = getOrthogonals(r)
      if (o.size>0)
        puts "#{i} -> "
        # p r
        puts o.inspect
        bases[i]=o
      end
    end
  }
  
  puts "bases=#{bases.inspect}"
else
  vecs = []
  for i in 3..40
    vecs+=vecs_with_square_length(i*i)
  end
  puts "Searching among #{vecs.inspect}"
  o = get30degrees(vecs)
  puts "pairs30=#{o.inspect}"
end
