require './header-footer.rb'

def primfaktoren(i)
  sign = i<0? "-" : ""
  i=i.abs
  faktoren = [0,0,0,0];
  f = 2
  while (i>1)
    while (i % f == 0)
      i/=f;
      faktoren[f]+=1
    end
    f+=1
    faktoren[f]=0
  end
  res = []
  faktoren.each.with_index{|f,i|
    if (f>0)
      if (f>1)
        res.push("#{i}^{#{f}}")
      else
        res.push(i.to_s)
      end
    end
  }
  return sign+res.join("\\cdot")
end

class Rational
  def to_tex(plus="", paren=false, primfakt=false)
    if paren && numerator<0
      paren = ["\\left(", "\\right)"]
    else
      paren = ["",""]
    end
    s=(numerator<0) ? "-" : plus
    if (denominator==1)
      return paren[0]+s+numerator.abs.to_s+paren[1]
    end
    if primfakt
      return s+paren[0]+"\\frac{#{primfaktoren(numerator.abs)}}{#{primfaktoren(denominator)}}"+paren[1]
    else
      return s+paren[0]+"\\frac{#{numerator.abs}}{#{denominator}}"+paren[1]
    end
  end
end




def randq()
  while true
    q = Rational(rand(5)+1, rand(5)+1)
    q = -q if rand(2)==0
    if (q.denominator!=1) && (q.numerator.abs != 1)
      return q
    end
  end
end

def randg1(q)
  return Rational(rand(5)+1, rand(5)+1)*(q**(-rand(2)-2))
end


def ex
  q = randq()
  g1 = randg1(q)
  n = rand(5)+8
  sn = g1*(1-q**n)/(1-q)
  sign = g1>0 ? "+" : "-"
  impl = "$s="+Array.new(4){|i|
    (g1*(q**i)).to_tex(i>0 ? "+" : "")
  }.join("")+sign+" \\ldots "+Array.new(3){|i|
    gn = g1*(q**(n-3+i))
    gn.to_tex("+", false, true)
#    (gn>0 ? "+" : "-")+
#    "\\frac{#{primfaktoren(gn.numerator.abs)}}{#{primfaktoren(gn.denominator.abs)}}"
  }.join("")+"$"

  sol = "$g_1=#{g1.to_tex}=#{g1.to_tex("",false, true)}$, $q=\\frac{g_2}{g_1} = #{q.to_tex}$, 
$\\frac{g_n}{g_1} = q^{n-1} = #{(q**(n-1)).to_tex("",false, true)}$ daraus folgt $n=#{n}$, "
  sol += "Resultat: $s_n=g_1 \\cdot \\frac{1-q^n}{1-q} = #{sn.to_tex}$"
  return [impl,sol]
end


name = "geomsum"
puts header(name)
p Array.new(10) { ex }
puts footer(name)

