# coding: utf-8
n = ARGV[0] ? ARGV[0].to_i : 3



def randline
  m = Rational((rand(2)*2-1)*(rand(3)+2),1)
  m = 1/m if (rand(2)==0)
  q = Rational((rand(2)*2-1)*(rand(3)+2),1)
  q = 1/q if (m.denominator==1)
  return [m,q]
end

def points(line)
  x=((-4..-1).to_a+(1..4).to_a).shuffle()[0..1].map{|x| Rational(x,1)}.sort
  return x.zip(x.map{|x| x*line[0]+line[1]})
end

def points_to_tex(pts)
  return pts.map{|e| "\\left("+e.map{|p| p.to_tex}.join(",")+"\\right)"}
end

class Rational
  def to_tex(plus="", paren=false)
    if paren && numerator<0
      paren = ["\\left(", "\\right)"]
    else
      paren = ["",""]
    end
    s=(numerator<0) ? "-" : plus
    if (denominator==1)
      return paren[0]+s+numerator.abs.to_s+paren[1]
    end
    return paren[0]+s+"\\frac{#{numerator.abs}}{#{denominator}}"+paren[1]
  end
end

ex = []
n.times{
  l = randline
  pts = points(l)
  p = points_to_tex(pts)
  sol = "$m = \\frac{\\Delta y}{\\Delta x} = \\frac{#{pts[1][1].to_tex}-#{pts[0][1].to_tex("", true)}}{#{pts[1][0].to_tex}-#{pts[0][0].to_tex("", true)}} = #{l[0].to_tex}$ (es wurden die Koordinaten von $B$ minus die Koordinaten von $A$ gerechnet).<br>"
  sol += "Für $q$ setzt man z.B. die Koordinaten von $A$ ein: $#{l[0].to_tex}\\cdot #{pts[0][0].to_tex("", true)} + q = #{pts[0][1].to_tex}$. Nach $q$ aufgelöst: $q=#{l[1].to_tex}$.<br>"
  sol += "$f(x) = #{l[0].to_tex}x #{l[1].to_tex("+")}$"
  ex.push(["$A=#{p[0]}$, $B=#{p[1]}$", sol]) 
}

p ex
