
class Rational
  def to_tex(plus="", paren=false)
    if paren && numerator<0
      paren = ["\\left(", "\\right)"]
    else
      paren = ["",""]
    end
    s=(numerator<0) ? "-" : plus
    if (denominator==1)
      return paren[0]+s+numerator.abs.to_s+paren[1]
    end
    return paren[0]+s+"\\frac{#{numerator.abs}}{#{denominator}}"+paren[1]
  end
end


def makeex
  while true
    q = Rational((rand(3)+2), rand(3)+2)
    if q.denominator>1 && q.numerator.abs>1
      g1 = Rational(q.denominator**(2+rand(2)), q.numerator**(2+rand(3)))
      n = rand(3)+3
      m = n+2+rand(3)
      gn = g1*q**(n-1)
      gm = g1*q**(m-1)
      ex = "Von einer GF mit lauter positiven Gliedern sind $g_{#{n}}=#{gn.to_tex}$ und $g_{#{m}}=#{gm.to_tex}$ bekannt. Berechnen Sie das erste Glied $g_1$ und den Quotienten $q$."
      sol = "$q=\\sqrt[#{m-n}]{\\frac{g_{#{m}}}{g_{#{n}}}} = \\sqrt[#{m-n}]{\\frac{#{gm.to_tex}}{#{gn.to_tex}}} = \\sqrt[#{m-n}]{#{gm.to_tex}\\cdot{#{(1/gn).to_tex}}} = \\sqrt[#{m-n}]{#{(gm/gn).to_tex}} = #{q.to_tex}$. Daraus folgt z.B. $g_1 = g_{#{n}} \\cdot \\left(#{q.to_tex}\\right)^{-(#{n}-1)} = g_{#{n}} \\cdot \\left(#{(1/q).to_tex}\\right)^{#{n-1}} = #{gn.to_tex} \\cdot #{((1/q)**(n-1)).to_tex} = #{g1.to_tex}$"
      return [ex,sol]
    end
  end

end

p Array.new(10) { makeex }
