# coding: utf-8
require "./header-footer.rb"



ex = [["\\mathrm{e}^{x^4}", "\\mathrm{e}^{x^4}\\cdot 4x^3"],
      ["\\ln\\left(x^5+x^4\\right)", "\\frac{1}{x^5+x^4}\\cdot \\left(5x^4+4x^3\\right)"],
      ["\\left(\\ln(x)\\right)^4", "4\\left(\\ln(x)\\right)^3 \\cdot \\frac{1}{x}"],
      ["\\sqrt{\\ln(x)}", "\\frac{1}{2\\sqrt{\\ln(x)}} \\cdot \\frac{1}{x}"],
      ["\\mathrm{e}^{\\sqrt{x}}", "\\mathrm{e}^{\\sqrt{x}} \\cdot \\frac{1}{2\\sqrt{x}}"],
      ["\\ln\\left(\\sqrt{x}\\right)", "\\frac{1}{\\sqrt{x}}\\cdot\\frac{1}{2\\sqrt{x}} \\text{ oder } \\frac{1}{2} \\cdot \\frac{1}{x}"],
      ["\\mathrm{e}^{\\mathrm{e}^x}", "\\mathrm{e}^{\\mathrm{e}^x} \\cdot \\mathrm{e}^x"],
      ["\\ln(\\ln(x))", "\\frac{1}{\\ln(x)} \\cdot \\frac{1}{x}"],
      ["\\sqrt{\\sqrt{x}}", "\\frac{1}{2 \\sqrt{\\sqrt{x}}} \\cdot \\frac{1}{2 \\sqrt{x}} \\text{ oder } \\frac{1}{4} \\cdot x^{-\\frac{3}{4}}"],
      ["\\left(x^4+1\\right)^9","9\\left(x^4+1)^8 \\cdot 4x^3"]]


name = "kettenregel"
res = "Leiten Sie folgende Ausdrücke mit Hilfe der Kettenregel nach $x$ ab (Vereinfachen ist nicht nötig):\n"


if ARGV[0].to_i==2
  ex=[["\\mathrm{e}^x \\cdot x^{-3}","\\mathrm{e}^x \\cdot x^{-3} + \\mathrm{e}^x \\cdot (-3)\\cdot x^{-4}"],
      ["\\mathrm{e}^x \\cdot \\ln(x)","\\mathrm{e}^x \\cdot \\ln(x) + \\mathrm{e}^x \\cdot \\frac{1}{x}"],
      ["x^{-4} \\cdot \\ln(x)", "(-4)\\cdot x^{-5} \\cdot \\ln(x) + x^{-4} \\cdot \\frac{1}{x}"],
      ["\\ln(x)\\cdot \\sqrt{x}", "\\frac{1}{x}\\cdot \\sqrt{x} + \\ln(x)\\frac{1}{2\\sqrt{x}}"],
      ["2^x \\cdot x^{-5}", "\\ln(2)2^x \\cdot x^{-5} + 2^x \\cdot (-5)\\cdot x^{-6}"],
      ["x^{-2} \\cdot \\sqrt{x}","(-2)\\cdot x^{-3} \\cdot \\sqrt{x} + x^{-2} \\cdot \\frac{1}{2\\sqrt{x}} \\text{ oder} -\\frac{3}{2} x^{-\\frac{5}{2}}"],
      ["x^{-7} \\cdot \\ln(x)", "(-7)\\cdot x^{-8}\\cdot \\ln(x) + x^{-7}\\cdot \\frac{1}{x}"]
     ]
  name = "produktregel"
  res = "Leiten Sie folgende Ausdrücke mit Hilfe der Produktregel nach $x$ ab (Vereinfachen ist nicht nötig):\n"
elsif ARGV[0].to_i==3
  ex=[["\\frac{x^3+x}{\\ln(x)}", "\\frac{\\left(3x^2+1\\right)\\cdot \\ln(x) - \\left(x^3+x\\right)\\cdot \\frac{1}{x}}{(\\ln(x))^2}"],
      ["\\frac{\\ln(x)}{x^3-3}","\\frac{\\frac{1}{x}\\cdot\\left(x^3-3\\right) - \\ln(x)\\cdot 3x^2}{\\left(x^3-3\\right)^2}"],
      ["\\frac{\\mathrm{e}^x+2}{\\mathrm{e}^x-x}","\\frac{\\mathrm{e}^x\\cdot\\left(\\mathrm{e}^x-x\\right) - \\left(\\mathrm{e}^x+2\\right)\\cdot\\left(\\mathrm{e}^x-1\\right)}{\\left(\\mathrm{e}^x-x\\right)^2}"],
      ["\\frac{\\sqrt{x}+2}{x^{-2}}","\\frac{\\frac{1}{2\\sqrt{x}}\\left(x^{-2}\\right) - \\left(\\sqrt{x}+2\\right)\\cdot(-2)\\cdot x^{-3}}{x^{-4}}"],
      ["\\frac{x^2-x^{-2}}{\\sqrt{x}}","\\frac{\\left(2x+2x^{-3}\\right)\\cdot \\sqrt{x} - \\frac{x^2-x^{-2}}{2\\sqrt{x}}}{x}"],
      ["\\frac{x}{1+\\mathrm{e}^x}","\\frac{1\\cdot \\left(1+\\mathrm{e}^x\\right) - x\\cdot \\mathrm{e}^x}{\\left(1+\\mathrm{e}^x\\right)^2}"],
      ["\\frac{\\ln(x)-x^{-2}}{\\ln(x)+x^2}", "\\frac{\\left(\\frac{1}{x}+2x^{-3}\\right)\\left(\\ln(x)+x^2\\right) - \\left(\\ln(x)-x^{-2}\\right)\\cdot\\left(\\frac{1}{x}+2x\\right)}{\\left(\\ln(x)+x^2\\right)^2}"],
     ]
  name = "quotientenregel"
  res = "Leiten Sie folgende Ausdrücke mit Hilfe der Quotientenregel nach $x$ ab (Vereinfachen ist nicht nötig):\n"
      
      
end


       
res += header(name)
res += ex.map{|e| e.map{|s| "$#{s}$"}}.inspect
res += footer(name, " $\\qquad$ ", " $\\qquad$ ", 3)
xclip(res)
