# coding: utf-8
require "./header-footer.rb"

class Rational
  def to_tex(op=false, amplify=1)
    if denominator==1
      return (op && self>=0 ? "+" : "")+to_s
    else
      s = numerator<0 ? "-" : (op ? "+" : "")
      return "#{s}\\frac{#{numerator.abs*amplify}}{#{denominator*amplify}}"
    end
  end  
end

def ncr(n,m)
  r = 1
  for x in (n-m+1)..n
    r*=x
  end
  for x in 2..m
    r/=x
  end
  return r
end

def combination()
  while true
    n = rand(8)+4
    m = rand(5)+3
    next if n-m<2
    l = ncr(n,m)
    puts "ncr(#{n},#{m})=#{l}"
    next if l>200
    next if l<50
    ex = "Wie viele Wörter der Länge $#{n}$ kann man mit genau $#{m}$ 'A' und genau $#{n-m}$ 'B' schreiben? "
    zaehler = ((n-m+1)..n).to_a.reverse.join(" \\cdot ")
    nenner = (1..m).to_a.reverse.join(" \\cdot ")
    sol = "Man platziert die Buchstaben 'A' auf je eine der $#{n}$ Position, einen Buchstaben nach dem anderen, dabei gibt es $#{zaehler}$ Möglichkeiten. Dabei werden aber Wörter mehrfach gebildet. Für ein bestimmtes Wort kann der erste Buchstaben 'A' auf $#{m}$ Positionen platziert werden, der nächste auf $#{m-1}$ etc. Jedes Wort wurde also $#{nenner}$-fach gebildet. Damit gibt total $\\frac{#{zaehler}}{#{nenner}} = #{l}$ Möglichkeiten."
    return [ex,sol]
  end
end

def variation()
  n = rand(8)+5
  m = rand(3)+2
  b = (0...m).to_a.map{|i| "'"+("A".ord+i).chr+"'"}.join(", ")
  ex = "Wie viele Wörter der Länge $#{n}$ kann man mit den Buchstaben #{b} schreiben, wenn jeder Buchstabe beliebig vielmal vorkommen kann?"
  total = "#{m}^{#{n}}"
  if (m**n<200)
    total += " = #{m**n}"
  end
  sol = "Es gibt total $#{m}$ Buchstaben, d.h. für jede Position haben wir genau $#{m}$ Möglichkeiten. Somit gibt es $#{total}$ Wörter."
  return [ex,sol]
end

def permutation()
  n = rand(6)+4
  b = (0...n).to_a.map{|i| "'"+("A".ord+i).chr+"'"}.join(", ")
  perm = (1..n).to_a.reverse.join(" \\cdot ")
  l = (1..n).inject(1){|a,b| a*b}
  if (l<200)
    perm += "=#{l}"
  end
  ex = "Wie viele Wörter kann mit den Buchstaben #{b} schreiben, wenn jeder Buchstabe genau einmal vorkommen muss?"
  sol = "Der erste Buchstaben kann auf $#{n}$ Positionen platziert werden, der zweite noch auf $#{n-1}$ etc. Es gibt also total $#{perm}$ solche Wörter."
  return [ex,sol]
end
  
type = ARGV[0]
res = "" 
if (type.to_i==1)
  name = "kombinatorik"

  all = Array.new(4) {combination()}
  all+= Array.new(4) {variation()}
  all+= Array.new(4) {permutation()}
  
  res = "Vollständig gekürzte Schlussresultate über 200 können als Rechnung stehen gelassen werden.\n"
  res += header(name)
  res += all.inspect
  res += footer(name, " <hr> ", " <hr> ")+"\n"
end

xclip(res)
