# coding: utf-8
require "./header-footer.rb"

class Rational
  def to_tex(op=false, amplify=1)
    if denominator==1
      return (op && self>=0 ? "+" : "")+to_s
    else
      s = numerator<0 ? "-" : (op ? "+" : "")
      return "#{s}\\frac{#{numerator.abs*amplify}}{#{denominator*amplify}}"
    end
  end  
end


def makeallex
  use=[[2,(5..10).to_a],
       [3,(3..4).to_a],
       [4,(3..5).to_a],
       [5,(2..4).to_a]]
  ex=[]
  use.each{|e|
    base = e[0]
    e[1].each{|exp|
      
      ex.push(["\\log_{#{base}}\\left(\\frac{1}{#{base**exp}}\\right)",-exp])
      ex.push(["\\log_{#{base}}\\left(#{base**exp}\\right)",exp])
    }
  }
  ex.shuffle!
  res = []
  0.step(ex.size-3,3){|i|
    e = ex[i..(i+2)].map{|x| x[0]}.join("+")
    r = ex[i..(i+2)].map{|x| x[1].to_s}.join("+") + "=" + ex[i..(i+2)].map{|x| x[1]}.inject(0){|a,b| a+b}.to_s
    res.push(["$#{e}$","$#{r}$"])
  }
  return res
end


def gesetze(num=10)
  return Array.new(num) {
    while true
      coef = Array.new(4) { (rand(4)+2)*(rand(2)*2-1) }
      mul = Array.new(2) {(rand(4)+2)*(rand(2)*2-1) }
      next if mul[0]==mul[1]
      next if coef[0]==coef[1] || coef[2]==coef[3]
      ex = "\\log_a\\left(\\left(x^{#{coef[0]}}y^{#{coef[1]}}\\right)^{#{mul[0]}}\\right)+"
      ex += "\\log_a\\left(\\left(x^{#{coef[2]}}y^{#{coef[3]}}\\right)^{#{mul[1]}}\\right)"
      c2 = coef[1]*mul[0]+coef[3]*mul[1]
      c1 = coef[0]*mul[0]+coef[2]*mul[1]
      next if c2==0 || c1==0
      sol = "\\begin{multline*}#{ex}=\\log_a\\left(\\left(x^{#{coef[0]}}y^{#{coef[1]}}\\right)^{#{mul[0]}} \\cdot \\left(x^{#{coef[2]}}y^{#{coef[3]}}\\right)^{#{mul[1]}}\\right) = \\\\"
      sol += "\\log_a\\left(x^{#{coef[0]*mul[0]}}y^{#{coef[1]*mul[0]}} \\cdot x^{#{coef[2]*mul[1]}}y^{#{coef[3]*mul[1]}}\\right) ="
      sol += "\\log_a\\left(x^{#{c1}} \\cdot y^{#{c2}} \\right) = \\\\"
      sol += "\\log_a\\left(x^{#{c1}}\\right) + \\log_a\\left(y^{#{c2}} \\right) = "
      c2 = (c2 >= 0 ? "+" : "")+c2.to_s
       sol += "#{coef[0]*mul[0]+coef[2]*mul[1]} \\log_a(x) #{c2}\\log_a(y)\\end{multline*}"
      break
    end
    ["$#{ex}$", "$#{sol}$"]
  }
end


def basiswechsel(num=10)
  use={2=>(3..10).to_a,
       3=>(3..4).to_a,
       5=> (2..4).to_a }
  res=[]
  use.keys.each{|b|
    for i in 0...(use[b].size)
      for j in 0...(use[b].size)
        if (i!=j)
          for s in 0..3            
            n = use[b][i]
            m = use[b][j]
            if (n%2==1)
              n=-n
            end
            if (n>1)
              m=-m
            end
            argn = n>0 ? b**n : "\\frac{1}{#{b**-n}}"
            argm = m>0 ? b**m : "\\frac{1}{#{b**-m}}"
            ex = "$\\log_{#{argn}}(#{argm})$"
            sol = "#{ex}=$\\frac{\\log_{#{b}}\\left(#{b}^{#{m}}\\right)}{\\log_{#{b}}\\left(#{b}^{#{n}}\\right)}=\\frac{#{m}}{#{n}}="
            r = Rational(m,n)
            if (r.numerator<0)
              sol+="-"
              r=-r
            end
            sol+="\\frac{#{r.numerator}}{#{r.denominator}}$"
            res.push([ex,sol])
          end
        end
      end
    end
  }
  return res.shuffle()[0...num]
end


def gleichungen(num=10)
  use={2=>(3..10).to_a,
       3=>(3..4).to_a,
       5=> (2..4).to_a }
  Array.new(num){
    base = use.keys.shuffle()[0]
    exp = use[base].shuffle()[0..1]
    exp.map!{|e| rand(2)==0 ? e : -e}
    b=Rational(rand(5)+2, rand(5)+2)
    c=Rational(rand(5)+2, rand(5)+2)
    begin
      b=Rational(rand(5)+2, rand(5)+2)*(rand(2)*2-1)
      c=Rational(rand(5)+2, rand(5)+2)*(rand(2)*2-1)
      x=(Rational(exp[1], exp[0])-c)/b
    end until x.denominator>1 && x.denominator<10 && b.denominator>1 && c.denominator>1
    bases = exp.map{|e| e>0 ? "#{base**e}" : "\\frac{1}{#{base**-e}}"}
    bases[0] = "\\left(#{bases[0]}\\right)" if exp[0]<0
    ex = "$#{bases[0]}^{#{b.to_tex}x#{c.to_tex(true)}}=#{bases[1]}$"
    eq = Rational(exp[1], exp[0])
    sol = "$\\begin{align*}
#{bases[0]}^{#{b.to_tex}x#{c.to_tex(true)}}&=#{bases[1]}&&|\\log_{#{base}}(\\cdot)\\\\
\\log_{#{base}}\\left(#{bases[0]}^{#{b.to_tex}x#{c.to_tex(true)}}\\right)&=\\log_{#{base}}\\left(#{base}^{#{exp[1]}}\\right)\\\\
\\left(#{b.to_tex}x#{c.to_tex(true)}\\right)\\cdot \\log_{#{base}}\\left(#{base}^{#{exp[0]}}\\right) & = #{exp[1]}\\\\
\\left(#{b.to_tex}x#{c.to_tex(true)}\\right)\\cdot #{exp[0]} & = #{exp[1]} && |:#{exp[0]}\\\\
#{b.to_tex}x#{c.to_tex(true)} & = #{eq.to_tex} && | #{(-c).to_tex(true)}\\\\
#{b.to_tex}x & = #{(eq-c).to_tex} && |:#{b.to_tex}\\\\
x & = #{((eq-c)/b).to_tex}
\\end{align*}$"
    [ex,sol]
  }
end


type = ARGV[0]
res = "" 
if (type.to_i==4)
  name = "expgleichung"
  res = "Lösen Sie die Gleichung von Hand auf:\n"
  res += header(name)
  res += gleichungen(10).inspect
  res += footer(name, " <hr> ", " <hr> ")+"\n"
elsif (type.to_i==3)
  name = "basiswechsel"
  res = "Berechnen Sie mit Hilfe eines geeigneten Basiswechsels:\n"
  res += header(name)
  res += basiswechsel().inspect
  res += footer(name, " <br> ")+"\n"
elsif (type.to_i==2)
  name = "loglaws"
  res = "Schreiben Sie als Linearkombination (Summe von Vielfachen) von $\\log_a(x)$ und $\\log_a(y)$\n"
  res += header(name)
  res += gesetze().inspect
  res += footer(name, " <br> ")+"\n"
else
  name = "logpot"
  
  
  res = "Berechnen Sie von Hand (Repetieren Sie dazu 2er Potenzen bis $2^{10}$, 3er Potenzen bis $3^4$, damit 4er bis $4^5$ und 5er Potenzen bis $5^4$).\n"
  res += header(name)
  res += makeallex().inspect
  res += footer(name, " <br> ")+"\n"
end
puts res
  
IO.popen("xclip", "w") {|f|
  f.puts res
}
puts "\n\n    -> Copied to X-Buffer (using xclip)"


  
      
