require 'fcntl'

class Maxima

  attr_reader :texput
  
  def initialize(debug=false)
    @maxima = Kernel.open("|maxima", Fcntl::O_NONBLOCK | Fcntl::O_RDWR)
#    puts get_output
    @input = []
    @output = []
    @texput = []
    @verbatim = false
    @label = "equation-01"
    @debug = debug
  end

  def command(line)
    puts "INPUT #{line}" if @debug
    @input.push(line)
    @maxima.puts line
    res = get_output
    @output.push(res)
    puts "OUTPUT #{res}" if @debug
    return res
  end

  def get_output
    res = ""
    begin
      sleep 0.01
      l = @maxima.sysread(200)
#      print l
      res += l
    end until res =~ /^\(%i\d+\)/
    puts "   RES: #{res}" if @debug
    res.gsub(/^\(%i\d+\).*/,"")
  end

  def quit
    @maxima.puts "quit();"
    @maxima.close
    @maxima = nil
    if @verbatim
      @texput.push("\\end{verbatim}")
      @verbatim = false
    end
  end

  def extractTeX(lines)
    line = lines.split.select{|l| l[0..1]=="$$" || l[-2..-1]=="$$"}.join("")[2...(-2)]
    line.gsub(/\\,/,"");
  end

  def extractString(line)
    line.gsub(/^\(%o\d+\)/,"").strip
  end

end

