# coding: utf-8

def factors(n)
  n=-n if n<0
  return n.to_s if n<=3
  res = []
  f = 2
  while (n>=f)
    z = 0
    while (n%f==0)
      z+=1
      n/=f
    end
    res.push([f,z]) if z>0
    f+=1
  end
  res.map{|p| p[1]==0 ? "" : "#{p[0]}"+ (p[1]>1 ? "^{#{p[1]}}" : "")}.join(" \\cdot ")
  
end

def kuerzen(a,b=nil)
  if a.is_a?(Rational)
    return kuerzen(a.numerator, a.denominator)
  end
  r = Rational(a,b)
  if r.denominator==1
    return factors(r.numerator)
  else
    return "\\frac{#{factors(r.numerator)}}{#{factors(r.denominator)}}"
  end
end

def nice_number()
  primes=[2,3,5,7]
  maxp = [5,3,3,1]
  taken = Array.new(maxp.size){|i| rand(maxp[i])+1}
  # p taken
  (0...maxp.size).to_a.shuffle[0..1].each{|i|
    taken[i] = 0
  }
  # p taken
  r = 1
  maxp.size.times{|i|
    r *= primes[i]**taken[i]
  }
  # puts r
  r
end

n = ARGV[0] ? ARGV[0].to_i : 3

e = Array.new(n) {
  n = Array.new(8){nice_number()}
  ex = "$\\frac{\\frac{#{n[0]}}{#{n[1]}} \\cdot \\frac{#{n[2]}}{#{n[3]}}}{\\frac{#{n[4]}}{#{n[5]}} : \\frac{#{n[6]}}{#{n[7]}}}$"
  
  sol = "$\\frac{\\frac{#{factors(n[0])}}{#{factors(n[1])}} \\cdot \\frac{#{factors(n[2])}}{#{factors(n[3])}}}{\\frac{#{factors(n[4])}}{#{factors(n[5])}} : \\frac{#{factors(n[6])}}{#{factors(n[7])}}} = "
  sol += "\\frac{#{kuerzen(n[0],n[1])} \\cdot #{kuerzen(n[2],n[3])}}{#{kuerzen(n[4],n[5])} \\cdot #{kuerzen(n[7],n[6])}} = "
  #sol += "\\frac{\\frac{#{factors(n[0]*n[2])}}{#{factors(n[1]*n[3])}}}{\\frac{#{factors(n[4]*n[7])}}{#{factors(n[5]*n[6])}}} = "
  sol += "\\frac{#{kuerzen(n[0]*n[2],n[1]*n[3])}}{#{kuerzen(n[4]*n[7],n[5]*n[6])}} = "
  sol += "#{kuerzen(n[0]*n[2],n[1]*n[3])} \\cdot #{kuerzen(n[5]*n[6],n[4]*n[7])} = "
  r = Array.new(4){|i| Rational(n[2*i],n[2*i+1])}
  res = r[0]*r[1]/r[2]*r[3]
  
  sol += kuerzen(res)+"$"
  [ex,sol]
}

puts "Berechnen Sie und geben Sie das Resultat als Bruch an, dessen Zählen und Nenner vollständig in Primfaktoren faktorisiert sind."

e.each{|ee|
  puts "  - $#{ee[0]}$"
}
puts "<hidden Lösungen>"
puts "Hinweis: Erst wo möglich kürzen, in Primfaktoren zerlegen, weiterkürzen, Doppelbrüche auflösen, weiter kürzen. Auf keinen Fall irgendwelche Multiplikationen ausrechnen!"
e.each{|ee|
  puts "  - $#{ee[1]}$"
}
puts "</hidden>"

