#declare cam_location = <15,2,8>;
// Kamera
camera { 
      sky <0,0,1>          // Vektor, der festlegt, wo oben ist.
      right <-4/3,0,0>     // Bildverhältnis 4:3, plus Spiegelung für rechtsdrehendes System
      location cam_location    // Position der Kamera
      look_at <0, 0, 1>    // Blickrichtung (erscheint im Bildmittelpunkt)
      angle 35             // Öffnungswinkel der Kamera
}
 
// Lichtquellen
/*
light_source { 
 <10,-6,28>              // Position des Lichts
 color rgb <1,1,1>     // Farbe des Lichts, als rot-grün-blau Vektor (Komponenten 0 bis 1)
}*/

light_source { 
 <10,12,30>              // Position des Lichts
 color rgb 2*<1,1,1>     // Farbe des Lichts, als rot-grün-blau Vektor (Komponenten 0 bis 1)
}
 
 
// Boden
plane { 
  z,0        // Ebene, senkrecht zu z=<0,0,1>, mit Abstand 0 zum Ursprung
  pigment {  // Schachbrett, durchsichtig (t steht für transmit, hier 80% lichtdurchlässig
    checker color rgb <1,1,1>, color rgb <0.2,0.2,0.2>
  }
}
 
 
// x-Achse 
cylinder { <-1,0,0>, <4,0,0>, 0.1  // Zylinder vom Ursprung 0=<0,0,0> zum Punkt 2*<1,0,0>=<2,0,0>, Raddiu 0.1
  pigment { color rgb <1,0,0> }  // Farbe rot
}
 
cone { 4*x, 0.2, 4.4*x, 0  // Kegel von <2,0,0> zu <2.4,0,0>, Startradius 0.2, Endradius 0
  pigment { color rgb x }  // Farble blau z=<0,0,1>
}
 
// y-Achse 
cylinder { -y, 4*y, 0.1  
  pigment { color rgb y } 
}
 
cone { 4*y, 0.2, 4.4*y, 0 
  pigment { color rgb y } 
}
 
// z-Achse 
cylinder { -z, 4*z, 0.1  
  pigment { color rgb z } 
}
 
cone { 4*z, 0.2, 4.4*z, 0  // Kegel von <2,0,0> zu <2.4,0,0>, Startradius 0.2, Endradius 0
  pigment { color rgb z }  // Farble blau z=<0,0,1>
}
  
#macro camText(wo, was, streckfaktor)
  #local mytext = text { ttf "timrom.ttf" was 0.1, <0,0,0> }
  #local newz = vnormalize(cam_location-wo)*streckfaktor;
  #local newx = vnormalize(vcross(z,newz))*streckfaktor;
  #local newy = vcross(newz, newx)/streckfaktor;
  object { mytext
         translate -(min_extent(mytext)+max_extent(mytext))/2
         matrix <newx.x, newx.y, newx.z,
                newy.x, newy.y, newy.z,
                newz.x, newz.y, newz.z,
                wo.x, wo.y, wo.z>
  }
#end

object { camText(4.5*x+0.5*z-0.5*y, "x", 0.8) pigment { color rgb x}}
object { camText(4.5*y+0.5*z, "y", 0.8) pigment { color rgb y}}
object { camText(4.5*z+0.5*y, "z", 0.8) pigment { color rgb 2*z+0.3*(x+y)}}
  
#include "code.pov"
  