# coding: utf-8
require "matrix"
require "./header-footer.rb"


class Vector
  def to_tex(vec=true)
    return "\\begin{pmatrix} "+self.map{|x| x}.to_a.join(" \\\\ ")+"\\end{pmatrix} " if vec
    return "\\left("+self.map{|x| x}.to_a.join(",\\,")+"\\right)"
  end
end


def makeex()
  vecs = Array.new(2){Vector.elements(Array.new(3){rand(10)*(rand(2)*2-1)})}
  cs = vecs[0].inner_product(vecs[1])/vecs[0].magnitude/vecs[1].magnitude
  w = Math.acos(cs)/Math::PI*180
  w = "%.3f" % w;
  ex = "$\\vec u = #{vecs[0].to_tex()},\\quad \\vec v= #{vecs[1].to_tex()}$"
  sol = "$\\sphericalangle\\left(\\vec u, \\vec v\\right) = \\arccos\\left(\\frac{\\vec u \\cdot \\vec v}{|\\vec u| \\cdot |\\vec v|}\\right) \\stackrel{TR}{\\approx} #{w}^{\\circ}$"
  return [ex,sol]
end

e = Array.new(10){makeex()}

name = "winkelzwischenvektorentr"
res = "Schreiben Sie die Formel zur Winkelberechnung zwischen zwei Vektoren auf und berechnen Sie den Winkel zwischen den beiden Vektoren mit Hilfe vom TR."
res += header(name)
res += e.inspect
res += footer(name, "<br><hr>", "<br><hr>")+"\n"

xclip(res)

