# coding: utf-8
require "./header-footer.rb"

class Rational
  def to_tex(op=false, amplify=1)
    if denominator==1
      return (op && self>=0 ? "+" : "")+to_i.to_s
    else
      s = numerator<0 ? "-" : (op ? "+" : "")
      return "#{s}\\frac{#{numerator.abs*amplify}}{#{denominator*amplify}}"
    end
  end  
end

def randRat(nmin, nmax, dmin, dmax)
  r = nil
  50.times{
    r = Rational(rand(nmax+1)+nmin, rand(dmax+1)+dmin)
    if r.denominator>=dmin
      r*=(rand(2)*2-1)
      return r
    end
  }
  return r
end




def exos()
  return [["ein Full-House zu werfen (3 Gleiche und 2 Gleiche).",
           "Es gibt $6\\cdot 5 =30$ Möglichkeiten für die Auswahl der Werte. \
Für die Positionierung des Tripel gibt es\
$\\binom{5}{3}=\\frac{5 \\cdot 4}{2 \\cdot 1} = 10$ Möglichkeiten. Total also 300 Möglichkeiten. \
Die Wahrscheinlichkeit ist damit $\\frac{300}{6^5} = \\frac{6 \\cdot 2 \\cdot 25}{6^5}  = \\frac{25}{3 \\cdot 6^3} = \\frac{25}{648}$"],
          ["eine grosse Strasse (5 aufeinander folgende Würfel) zu werfen.",
           "Es gibt 2 Werte-Kombinationen (1 bis 5 oder 2 bis 6). Diese können auf $5!=120$ Arten angeordnet werden.
Total also $240$ Möglichkeiten. Die Wahrscheinlichkeit ist damit $\\frac{240}{6^5} = \\frac{6 \\cdot 4 \\cdot 2\\cdot 5}{6^5} =\ 
\\frac{5}{3^3\\cdot 6} = \\frac{5}{162}$"],
          ["einen Dreier-Pasch (3 Gleiche) zu werfen.",
           "Für die Werte gibt es 6 Möglichkeiten für den Tripel, und je 5 für die beiden anderen Würfel, total also 
$6\\cdot 5^2=150$ Möglichkeiten. Um den Tripel anzuordnen gibt es $\\binom{5}{3}=\\frac{5 \\cdot 4}{2 \\cdot 1} = 10$ Möglichkeiten. Total also $1500$ Möglichkeiten. Die Wahrscheinlichkeit ist damit $\\frac{1500}{6^5} = \\frac{6 \\cdot 2 \\cdot 5^3}{6^5} =\ 
\\frac{5^3}{3 6^3} = \\frac{125}{648}$"],
          ["einen Vierer-Pasch (4 Gleiche) zu werden.",
           "Für die Werte gibt es 6 Möglichkeiten für den Vierer-Pasch, und 5 für den letzten Würfel, total also 
$6\\cdot 5=30$ Möglichkeiten. Um den letzten Würfel zu platzieren gibt es $\\binom{5}{1}=5$ Möglichkeiten. Total also $150$ Möglichkeiten. Die Wahrscheinlichkeit ist damit $\\frac{150}{6^5} = \\frac{6 \\cdot 25}{6^5} =\ 
\\frac{5^2}{6^4} = \\frac{25}{1296}$"],
          ["dass alle Würfel 4 oder mehr zeigen.",
           "Die Wahrscheinlichkeit, dass ein Würfel 4 oder mehr zeigt (3 aus 6 möglichen Werten) ist $\\frac{1}{2}$, damit ist die\
Wahrscheinlichkeit, dass alle 4 oder mehr zeigen $\\left(\\frac{1}{2}\\right)^5 = \\frac{1}{32}$."],
         ]
  
end


  
type = ARGV[0]
res = "" 
if (type.to_i==1)
  name = "yahtzee"

  all = exos()
  
  res = "Es wird mit 5 normalen Spielwürfeln geworfen. Potenzen in Resultaten dürfen stehen gelassen werden, es muss aber vollständig gekürzt werden! Berechnen Sie die Wahscheinlichkeit\n"
  res += header(name)
  res += all.inspect
  res += footer(name, " <hr> ", " <hr> ")+"\n"

end

xclip(res)
